#include "common.h"
#include "const.h"
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

#include <cstring>
#include <cstdlib>


void MS::Configuration(int _self_idx,int _self_sector_idx)
{
	self_idx = _self_idx;
	self_sector_idx = _self_sector_idx;
	Set_MS_Location();
	
}

void MS::Set_MS_Location()
{
	//////////// Hex grid MS configuration //////////////////////////
	/*
	INPUT:
	OUTPUT: MS location
	Notes: MS 
	*/

	double angle;
	double R;
	double cell_radius = inter_site_distance * (1 / sqrt(3.));

	do
	{
		loc.x = cell_radius*randnum.u();
		loc.y = ((sqrt(3.) / 2.) * cell_radius + (sqrt(3.) / 4.) * cell_radius) * randnum.u() - ((sqrt(3.) / 4.) * cell_radius); // ó ,  1  ū 簢.

	}while ((sqrt(loc.x * loc.x + loc.y * loc.y) < min_distance) || (loc.y > (-1. * sqrt(3.)) * loc.x + (sqrt(3.)*cell_radius)) || (loc.y < (-1./sqrt(3.)) * loc.x) || (loc.y < sqrt(3.) * loc.x - sqrt(3.) * cell_radius));
	

	angle = atan(loc.y / loc.x) * 180./pi;

	R = sqrt(loc.x*loc.x + loc.y*loc.y);

	//////////////////////////////////////////// 3 Sector /////////////
	if (self_sector_idx == 2)
	{
		angle = angle + 120;
		loc.x = R*cos(angle*pi / 180.);
		loc.y = R*sin(angle*pi / 180.);

	}
	else if (self_sector_idx == 3)
	{
		angle = angle + 240;
		loc.x = R*cos(angle*pi / 180.);
		loc.y = R*sin(angle*pi / 180.);

	}


	//loc.x = R*cos(angle*pi / 180.);
	//loc.y = R*sin(angle*pi / 180.);


	////////////////////////////////////////////////// Indoor or Outdoor /////////////////////////////////
	
	if (TYPE == 12)  //// IMT-2020 , Dense Urban eMBB
	{
		if (randnum.u() < 0.8) // indoor
		{
			Indoor = true;
		}
		else
		{
			Indoor = false;
		}

	}
	else if (TYPE == 13)  //// IMT-2020 , Rural eMBB
	{
		if (Configuration_Type == 2)    ///// configuration C -> 40% indoor, 20% outdoor pedestrian, 20% outdoor in car
		{
			if (randnum.u() < 0.4) // indoor 40%
			{
				Indoor = true;
			}
			else
			{
				Indoor = false;
			}

		}
		else
		{
			if (randnum.u() < 0.5) // indoor
			{
				Indoor = true;
			}
			else
			{
				Indoor = false;
			}

		}
		

	}
	else
	{
		Indoor = false;
	}




	

}

void MS::Allocate_memory()
{

	if (test_environment > 2)
	{
		pos = new LOCATION[19];
	}

	//_2D_distance = new double[num_bs];
	//break_point_distance = new double[num_bs];
	//pathloss = new double[num_bs];
	//los = new bool[num_bs];
	//propagation_condition = new int[num_BS];
	TLSPs = new ArrayXd[num_BS];

	//antennagain = new double[num_sectors];
	//ue2sector_azimuth_angle = new double[num_sectors];
	//LS_gain = new double[num_sectors];

	//adj_sector = new int[num_compute_coef];

	sigma_SF = new double[num_BS];
	shadow_fading = new double[num_BS];
}

void MS::Delete_memory()
{
	//delete[]_2D_distance;
	//delete[]ue2sector_azimuth_angle;
	//delete[] los;
	//delete[]pathloss;
	//delete[] antennagain;
	//delete[] LS_gain;
	//delete[]break_point_distance;
	//delete[] adj_sector;

	if (test_environment > 2)
	{
		delete[] pos;
	}
	delete[]TLSPs;
	//delete[]propagation_condition;

	delete[]sigma_SF;
	delete[]shadow_fading;
}




/*===================================================================
FUNCTION: UE::return_throughput( void )



===================================================================*/
/*
double MS::Return_Throughput(int _ms_idx)
{
	return(link[_ms_idx]._throughput);
}


void MS::Kill_Memory(void)
{
	

	delete[] H_m;


	for (int i = 0; i < num_compute_coef - 1; i++)
	{
		delete[] HI_m[i];
	}

	delete[] HI_m;


}
*/